import { EndpointParameterInstructions } from "@aws-sdk/middleware-endpoint";
import { Command as $Command } from "@aws-sdk/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@aws-sdk/types";
import {
  ListSecretVersionIdsRequest,
  ListSecretVersionIdsResponse,
} from "../models/models_0";
import {
  SecretsManagerClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../SecretsManagerClient";
export interface ListSecretVersionIdsCommandInput
  extends ListSecretVersionIdsRequest {}
export interface ListSecretVersionIdsCommandOutput
  extends ListSecretVersionIdsResponse,
    __MetadataBearer {}
export declare class ListSecretVersionIdsCommand extends $Command<
  ListSecretVersionIdsCommandInput,
  ListSecretVersionIdsCommandOutput,
  SecretsManagerClientResolvedConfig
> {
  readonly input: ListSecretVersionIdsCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: ListSecretVersionIdsCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: SecretsManagerClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<
    ListSecretVersionIdsCommandInput,
    ListSecretVersionIdsCommandOutput
  >;
  private serialize;
  private deserialize;
}
