import { EndpointParameterInstructions } from "@aws-sdk/middleware-endpoint";
import { Command as $Command } from "@aws-sdk/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@aws-sdk/types";
import {
  ReplicateSecretToRegionsRequest,
  ReplicateSecretToRegionsResponse,
} from "../models/models_0";
import {
  SecretsManagerClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../SecretsManagerClient";
export interface ReplicateSecretToRegionsCommandInput
  extends ReplicateSecretToRegionsRequest {}
export interface ReplicateSecretToRegionsCommandOutput
  extends ReplicateSecretToRegionsResponse,
    __MetadataBearer {}
export declare class ReplicateSecretToRegionsCommand extends $Command<
  ReplicateSecretToRegionsCommandInput,
  ReplicateSecretToRegionsCommandOutput,
  SecretsManagerClientResolvedConfig
> {
  readonly input: ReplicateSecretToRegionsCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: ReplicateSecretToRegionsCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: SecretsManagerClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<
    ReplicateSecretToRegionsCommandInput,
    ReplicateSecretToRegionsCommandOutput
  >;
  private serialize;
  private deserialize;
}
