import { EndpointParameterInstructions } from "@aws-sdk/middleware-endpoint";
import { Command as $Command } from "@aws-sdk/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@aws-sdk/types";
import {
  UpdateSecretVersionStageRequest,
  UpdateSecretVersionStageResponse,
} from "../models/models_0";
import {
  SecretsManagerClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../SecretsManagerClient";
export interface UpdateSecretVersionStageCommandInput
  extends UpdateSecretVersionStageRequest {}
export interface UpdateSecretVersionStageCommandOutput
  extends UpdateSecretVersionStageResponse,
    __MetadataBearer {}
export declare class UpdateSecretVersionStageCommand extends $Command<
  UpdateSecretVersionStageCommandInput,
  UpdateSecretVersionStageCommandOutput,
  SecretsManagerClientResolvedConfig
> {
  readonly input: UpdateSecretVersionStageCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: UpdateSecretVersionStageCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: SecretsManagerClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<
    UpdateSecretVersionStageCommandInput,
    UpdateSecretVersionStageCommandOutput
  >;
  private serialize;
  private deserialize;
}
