import {
  HttpRequest as __HttpRequest,
  HttpResponse as __HttpResponse,
} from "@aws-sdk/protocol-http";
import { SerdeContext as __SerdeContext } from "@aws-sdk/types";
import {
  CancelRotateSecretCommandInput,
  CancelRotateSecretCommandOutput,
} from "../commands/CancelRotateSecretCommand";
import {
  CreateSecretCommandInput,
  CreateSecretCommandOutput,
} from "../commands/CreateSecretCommand";
import {
  DeleteResourcePolicyCommandInput,
  DeleteResourcePolicyCommandOutput,
} from "../commands/DeleteResourcePolicyCommand";
import {
  DeleteSecretCommandInput,
  DeleteSecretCommandOutput,
} from "../commands/DeleteSecretCommand";
import {
  DescribeSecretCommandInput,
  DescribeSecretCommandOutput,
} from "../commands/DescribeSecretCommand";
import {
  GetRandomPasswordCommandInput,
  GetRandomPasswordCommandOutput,
} from "../commands/GetRandomPasswordCommand";
import {
  GetResourcePolicyCommandInput,
  GetResourcePolicyCommandOutput,
} from "../commands/GetResourcePolicyCommand";
import {
  GetSecretValueCommandInput,
  GetSecretValueCommandOutput,
} from "../commands/GetSecretValueCommand";
import {
  ListSecretsCommandInput,
  ListSecretsCommandOutput,
} from "../commands/ListSecretsCommand";
import {
  ListSecretVersionIdsCommandInput,
  ListSecretVersionIdsCommandOutput,
} from "../commands/ListSecretVersionIdsCommand";
import {
  PutResourcePolicyCommandInput,
  PutResourcePolicyCommandOutput,
} from "../commands/PutResourcePolicyCommand";
import {
  PutSecretValueCommandInput,
  PutSecretValueCommandOutput,
} from "../commands/PutSecretValueCommand";
import {
  RemoveRegionsFromReplicationCommandInput,
  RemoveRegionsFromReplicationCommandOutput,
} from "../commands/RemoveRegionsFromReplicationCommand";
import {
  ReplicateSecretToRegionsCommandInput,
  ReplicateSecretToRegionsCommandOutput,
} from "../commands/ReplicateSecretToRegionsCommand";
import {
  RestoreSecretCommandInput,
  RestoreSecretCommandOutput,
} from "../commands/RestoreSecretCommand";
import {
  RotateSecretCommandInput,
  RotateSecretCommandOutput,
} from "../commands/RotateSecretCommand";
import {
  StopReplicationToReplicaCommandInput,
  StopReplicationToReplicaCommandOutput,
} from "../commands/StopReplicationToReplicaCommand";
import {
  TagResourceCommandInput,
  TagResourceCommandOutput,
} from "../commands/TagResourceCommand";
import {
  UntagResourceCommandInput,
  UntagResourceCommandOutput,
} from "../commands/UntagResourceCommand";
import {
  UpdateSecretCommandInput,
  UpdateSecretCommandOutput,
} from "../commands/UpdateSecretCommand";
import {
  UpdateSecretVersionStageCommandInput,
  UpdateSecretVersionStageCommandOutput,
} from "../commands/UpdateSecretVersionStageCommand";
import {
  ValidateResourcePolicyCommandInput,
  ValidateResourcePolicyCommandOutput,
} from "../commands/ValidateResourcePolicyCommand";
export declare const serializeAws_json1_1CancelRotateSecretCommand: (
  input: CancelRotateSecretCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1CreateSecretCommand: (
  input: CreateSecretCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1DeleteResourcePolicyCommand: (
  input: DeleteResourcePolicyCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1DeleteSecretCommand: (
  input: DeleteSecretCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1DescribeSecretCommand: (
  input: DescribeSecretCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1GetRandomPasswordCommand: (
  input: GetRandomPasswordCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1GetResourcePolicyCommand: (
  input: GetResourcePolicyCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1GetSecretValueCommand: (
  input: GetSecretValueCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1ListSecretsCommand: (
  input: ListSecretsCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1ListSecretVersionIdsCommand: (
  input: ListSecretVersionIdsCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1PutResourcePolicyCommand: (
  input: PutResourcePolicyCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1PutSecretValueCommand: (
  input: PutSecretValueCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1RemoveRegionsFromReplicationCommand: (
  input: RemoveRegionsFromReplicationCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1ReplicateSecretToRegionsCommand: (
  input: ReplicateSecretToRegionsCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1RestoreSecretCommand: (
  input: RestoreSecretCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1RotateSecretCommand: (
  input: RotateSecretCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1StopReplicationToReplicaCommand: (
  input: StopReplicationToReplicaCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1TagResourceCommand: (
  input: TagResourceCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1UntagResourceCommand: (
  input: UntagResourceCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1UpdateSecretCommand: (
  input: UpdateSecretCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1UpdateSecretVersionStageCommand: (
  input: UpdateSecretVersionStageCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1ValidateResourcePolicyCommand: (
  input: ValidateResourcePolicyCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const deserializeAws_json1_1CancelRotateSecretCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<CancelRotateSecretCommandOutput>;
export declare const deserializeAws_json1_1CreateSecretCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<CreateSecretCommandOutput>;
export declare const deserializeAws_json1_1DeleteResourcePolicyCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DeleteResourcePolicyCommandOutput>;
export declare const deserializeAws_json1_1DeleteSecretCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DeleteSecretCommandOutput>;
export declare const deserializeAws_json1_1DescribeSecretCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DescribeSecretCommandOutput>;
export declare const deserializeAws_json1_1GetRandomPasswordCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetRandomPasswordCommandOutput>;
export declare const deserializeAws_json1_1GetResourcePolicyCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetResourcePolicyCommandOutput>;
export declare const deserializeAws_json1_1GetSecretValueCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetSecretValueCommandOutput>;
export declare const deserializeAws_json1_1ListSecretsCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<ListSecretsCommandOutput>;
export declare const deserializeAws_json1_1ListSecretVersionIdsCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<ListSecretVersionIdsCommandOutput>;
export declare const deserializeAws_json1_1PutResourcePolicyCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<PutResourcePolicyCommandOutput>;
export declare const deserializeAws_json1_1PutSecretValueCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<PutSecretValueCommandOutput>;
export declare const deserializeAws_json1_1RemoveRegionsFromReplicationCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<RemoveRegionsFromReplicationCommandOutput>;
export declare const deserializeAws_json1_1ReplicateSecretToRegionsCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<ReplicateSecretToRegionsCommandOutput>;
export declare const deserializeAws_json1_1RestoreSecretCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<RestoreSecretCommandOutput>;
export declare const deserializeAws_json1_1RotateSecretCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<RotateSecretCommandOutput>;
export declare const deserializeAws_json1_1StopReplicationToReplicaCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<StopReplicationToReplicaCommandOutput>;
export declare const deserializeAws_json1_1TagResourceCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<TagResourceCommandOutput>;
export declare const deserializeAws_json1_1UntagResourceCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<UntagResourceCommandOutput>;
export declare const deserializeAws_json1_1UpdateSecretCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<UpdateSecretCommandOutput>;
export declare const deserializeAws_json1_1UpdateSecretVersionStageCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<UpdateSecretVersionStageCommandOutput>;
export declare const deserializeAws_json1_1ValidateResourcePolicyCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<ValidateResourcePolicyCommandOutput>;
