import { EndpointParameterInstructions } from "@aws-sdk/middleware-endpoint";
import { Command as $Command } from "@aws-sdk/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@aws-sdk/types";
import {
  UpdateMaintenanceWindowTaskRequest,
  UpdateMaintenanceWindowTaskResult,
} from "../models/models_2";
import {
  ServiceInputTypes,
  ServiceOutputTypes,
  SSMClientResolvedConfig,
} from "../SSMClient";
export interface UpdateMaintenanceWindowTaskCommandInput
  extends UpdateMaintenanceWindowTaskRequest {}
export interface UpdateMaintenanceWindowTaskCommandOutput
  extends UpdateMaintenanceWindowTaskResult,
    __MetadataBearer {}
export declare class UpdateMaintenanceWindowTaskCommand extends $Command<
  UpdateMaintenanceWindowTaskCommandInput,
  UpdateMaintenanceWindowTaskCommandOutput,
  SSMClientResolvedConfig
> {
  readonly input: UpdateMaintenanceWindowTaskCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: UpdateMaintenanceWindowTaskCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: SSMClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<
    UpdateMaintenanceWindowTaskCommandInput,
    UpdateMaintenanceWindowTaskCommandOutput
  >;
  private serialize;
  private deserialize;
}
